#ifndef DEVEL__MKMED__STRERR_H
#define DEVEL__MKMED__STRERR_H

#define die1(status, x1, se) \
  ((void)(""==(x1)), \
   strerr_die1((status), (char*)(x1), (se)))

#define die2(status, x1, x2, se) \
  ((void)(""==(x1)), (void)(""==(x2)), \
   strerr_die2((status), (char*)(x1), (char*)(x2), (se)))

#define die3(status, x1, x2, x3, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), \
   strerr_die3((status), (char*)(x1), (char*)(x2), (char*)(x3), (se)))

#define die4(status, x1, x2, x3, x4, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   strerr_die4((status), (char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), \
               (se)))

#define die5(status, x1, x2, x3, x4, x5, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   (void)(""==(x5)), \
   strerr_die5((status), (char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), \
               (char*)(x5), (se)))

#define die6(status, x1, x2, x3, x4, x5, x6, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   (void)(""==(x5)), (void)(""==(x6)), \
   strerr_die6((status), (char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), \
               (char*)(x5), (char*)(x6), (se)))

#define die1x(status, x1) \
        die1((status), (x1), null)
#define die2x(status, x1, x2) \
        die2((status), (x1), (x2), null)
#define die3x(status, x1, x2, x3) \
        die3((status), (x1), (x2), (x3), null)
#define die4x(status, x1, x2, x3, x4) \
        die4((status), (x1), (x2), (x3), (x4), null)
#define die5x(status, x1, x2, x3, x4, x5) \
        die5((status), (x1), (x2), (x3), (x4), (x5), null)
#define die6x(status, x1, x2, x3, x4, x5, x6) \
        die6((status), (x1), (x2), (x3), (x4), (x5), (x6), null)

#define die1sys(status, x1) \
        die1((status), (x1), &strerr_sys)
#define die2sys(status, x1, x2) \
        die2((status), (x1), (x2), &strerr_sys)
#define die3sys(status, x1, x2, x3) \
        die3((status), (x1), (x2), (x3), &strerr_sys)
#define die4sys(status, x1, x2, x3, x4) \
        die4((status), (x1), (x2), (x3), (x4), &strerr_sys)
#define die5sys(status, x1, x2, x3, x4, x5) \
        die5((status), (x1), (x2), (x3), (x4), (x5), &strerr_sys)
#define die6sys(status, x1, x2, x3, x4, x5, x6) \
        die6((status), (x1), (x2), (x3), (x4), (x5), (x6), &strerr_sys)

#define warn1(x1, se) \
  ((void)(""==(x1)), \
   strerr_warn1((char*)(x1), (se)))

#define warn2(x1, x2, se) \
  ((void)(""==(x1)), (void)(""==(x2)), \
   strerr_warn2((char*)(x1), (char*)(x2), (se)))

#define warn3(x1, x2, x3, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), \
   strerr_warn3((char*)(x1), (char*)(x2), (char*)(x3), (se)))

#define warn4(x1, x2, x3, x4, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   strerr_warn4((char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), (se)))

#define warn5(x1, x2, x3, x4, x5, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   (void)(""==(x5)), \
   strerr_warn5((char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), \
                (char*)(x5), (se)))

#define warn6(x1, x2, x3, x4, x5, x6, se) \
  ((void)(""==(x1)), (void)(""==(x2)), (void)(""==(x3)), (void)(""==(x4)), \
   (void)(""==(x5)), (void)(""==(x6)), \
   strerr_warn6((char*)(x1), (char*)(x2), (char*)(x3), (char*)(x4), \
                (char*)(x5), (char*)(x6), (se)))

#define warn1x(x1) \
        warn1((x1), null)
#define warn2x(x1, x2) \
        warn2((x1), (x2), null)
#define warn3x(x1, x2, x3) \
        warn3((x1), (x2), (x3), null)
#define warn4x(x1, x2, x3, x4) \
        warn4((x1), (x2), (x3), (x4), null)
#define warn5x(x1, x2, x3, x4, x5) \
        warn5((x1), (x2), (x3), (x4), (x5), null)
#define warn6x(x1, x2, x3, x4, x5, x6) \
        warn6((x1), (x2), (x3), (x4), (x5), (x6), null)

#define warn1sys(x1) \
        warn1((x1), &strerr_sys)
#define warn2sys(x1, x2) \
        warn2((x1), (x2), &strerr_sys)
#define warn3sys(x1, x2, x3) \
        warn3((x1), (x2), (x3), &strerr_sys)
#define warn4sys(x1, x2, x3, x4) \
        warn4((x1), (x2), (x3), (x4), &strerr_sys)
#define warn5sys(x1, x2, x3, x4, x5) \
        warn5((x1), (x2), (x3), (x4), (x5), &strerr_sys)
#define warn6sys(x1, x2, x3, x4, x5, x6) \
        warn6((x1), (x2), (x3), (x4), (x5), (x6), &strerr_sys)

#endif
